﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class RobotinOhjaus : MonoBehaviour
{
    Rigidbody rb;
    Animator animaattori;
    public float liikkumisNopeus = 2.5f;
    public float kääntymisNopeus = 200f;
    public Transform yläosa;
    public LayerMask säteenVaikutus;

    void Start()
    {
        rb = GetComponent<Rigidbody>();
        animaattori = GetComponent<Animator>();
    }

    void FixedUpdate()
    {
        float pystysuora = Input.GetAxisRaw("Vertical");
        Vector3 siirtymä = transform.forward * pystysuora * liikkumisNopeus * Time.deltaTime;
        rb.MovePosition(transform.position + siirtymä);
        float vaakasuora = Input.GetAxisRaw("Horizontal");
        Quaternion kääntymä = Quaternion.Euler(0, vaakasuora * kääntymisNopeus * Time.deltaTime, 0);
        rb.MoveRotation(rb.rotation * kääntymä);
        animaattori.SetBool("kävelee", pystysuora != 0 || vaakasuora != 0);
    }

    void Update()
    {
        if (Time.timeScale == 0)
            return;

        Ray säde = Camera.main.ScreenPointToRay(Input.mousePosition);
        RaycastHit osuma;
        if (Physics.Raycast(säde, out osuma, 100, säteenVaikutus))
        {
            Vector3 katsomisSuunta = osuma.point - transform.position;
            katsomisSuunta.y = 0;
            yläosa.rotation = Quaternion.LookRotation(katsomisSuunta);
        }
    }
}
