﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.AI;

public class VihollisenLiikkuminen : MonoBehaviour
{

    NavMeshAgent agentti;
    Transform robotti;
    Animator animaattori;
    Vector3 määränpää;
    RobotinKuoleminen robotinKuoleminen;
    public float hyökkäysLujuus = 15f;
    public float hyökkäysNopeus = 2f;
    float viimeHyökkäys;

    bool syntynyt;

    void Start()
    {
        agentti = GetComponent<NavMeshAgent>();
        määränpää = agentti.destination;
        robotti = GameObject.Find("Robotti").transform;
        robotinKuoleminen = robotti.GetComponent<RobotinKuoleminen>();
        animaattori = GetComponent<Animator>();
    }

    void Update()
    {
        if (!syntynyt)
            return;
        if (Time.time - viimeHyökkäys >= hyökkäysNopeus)
        {
            if (agentti.hasPath && agentti.remainingDistance <= agentti.stoppingDistance)
            {
                animaattori.SetTrigger("hyökkää");
                viimeHyökkäys = Time.time;
            }
        }

        if (Vector3.Distance(robotti.position, määränpää) > 1.0f)
        {
            määränpää = robotti.position;
            agentti.destination = määränpää;
        }
    }

    public void TuotaVahinkoa()
    {
        robotinKuoleminen.Elämäpisteet -= hyökkäysLujuus;
        ElämäpisteetPalkki.instanssi.Päivitä(robotinKuoleminen.Elämäpisteet);
    }

    public void Syntyi()
    {
        syntynyt = true;
    }

}
